%define brcmname netxtreme2
%define brcmvers 4.8.22

%define debug_package %{nil}

Summary  : Broadcom NetXtreme II 1-Gigabit and 10-Gigabit ethernet drivers
Name     : netxtreme2
Version  : %{brcmvers}
Release  : 1
Vendor   : Broadcom Corporation
License  : GPL
Group    : System Environment/Base
Source   : %{brcmname}-%{brcmvers}.tar.bz2
BuildRoot: /var/tmp/%{brcmname}-buildroot

%description
This package contains the Broadcom NetXtreme II 1-Gigabit (bnx2) and 10-Gigabit (bnx2x) ethernet drivers.

%prep
%setup -n %{brcmname}-%{brcmvers} -T -b 0

%build
if [ -n "%{?KVER}" ]; then
	KVER=%{?KVER}
elif [ -n "${BUILD_KERNEL}" ]; then
	KVER=${BUILD_KERNEL}
else
	KVER=$(uname -r)
fi
make KVER=$KVER

%install
if [ -n "%{?KVER}" ]; then
	KVER=%{?KVER}
elif [ -n "${BUILD_KERNEL}" ]; then
	KVER=${BUILD_KERNEL}
else
	KVER=$(uname -r)
fi

BCM_KVER=`echo $KVER | cut -c1-3 | sed 's/2\.[56]/2\.6/'`
if [ "$BCM_KVER" = "2.6" ];then
	BCM_CNIC=`echo $KVER | cut -c5- | cut -d. -f1 | cut -d- -f1 | awk '{ if ($1 > 15) print "1"; else print "0"}'`
	BCM_EXT=ko
else
	BCM_CNIC=0
	BCM_EXT=o
fi
if [ -d /lib/modules/$KVER/updates ]; then
	BCM_DIR=updates
else
	BCM_DIR=kernel/drivers/net
fi

echo "%defattr(-,root,root)" > $RPM_BUILD_DIR/file.list.%{brcmname}
echo "/lib/modules/$KVER/$BCM_DIR/bnx2.${BCM_EXT}" >> $RPM_BUILD_DIR/file.list.%{brcmname}
echo "/lib/modules/$KVER/$BCM_DIR/bnx2x.${BCM_EXT}" >> $RPM_BUILD_DIR/file.list.%{brcmname}
if [ "$BCM_CNIC" = "1" ];then
echo "/lib/modules/$KVER/$BCM_DIR/cnic.ko" >> $RPM_BUILD_DIR/file.list.%{brcmname}
echo "/usr/src/bnx2/bnx2.h"    >> $RPM_BUILD_DIR/file.list.%{brcmname}
echo "/usr/src/bnx2/cnic_if.h" >> $RPM_BUILD_DIR/file.list.%{brcmname}
echo "/usr/src/bnx2/cnic_drv.h" >> $RPM_BUILD_DIR/file.list.%{brcmname}
fi
mkdir -p $RPM_BUILD_ROOT/lib/modules/$KVER/$BCM_DIR

echo "/usr/share/man/man4/bnx2.4.*"  >> $RPM_BUILD_DIR/file.list.%{brcmname}
echo "/usr/share/man/man4/bnx2x.4.*" >> $RPM_BUILD_DIR/file.list.%{brcmname}
mkdir -p $RPM_BUILD_ROOT/usr/share/man/man4

make install KVER=$KVER PREFIX=$RPM_BUILD_ROOT
if [ -d $RPM_BUILD_ROOT/lib/modules/$KVER/extra ];then

	BCM_EXTRA_DIR=$RPM_BUILD_ROOT/lib/modules/$KVER/extra
	BCM_FINAL_DIR=$RPM_BUILD_ROOT/lib/modules/$KVER/${BCM_DIR}

	if [ -f ${BCM_EXTRA_DIR}/bnx2.${BCM_EXT} ];then
		mv ${BCM_EXTRA_DIR}/bnx2.${BCM_EXT} ${BCM_FINAL_DIR}
	fi

	if [ -f ${BCM_EXTRA_DIR}/bnx2x.${BCM_EXT} ];then
		mv ${BCM_EXTRA_DIR}/bnx2x.${BCM_EXT} ${BCM_FINAL_DIR}
	fi

	if [ -f ${BCM_EXTRA_DIR}/cnic.ko ];then
		mv ${BCM_EXTRA_DIR}/cnic.ko ${BCM_FINAL_DIR}
	fi

	if [ -z "`ls ${BCM_EXTRA_DIR}`" ]; then
		rmdir ${BCM_EXTRA_DIR}
	fi
fi

cp -f bnx2/LICENSE      .
cp -f bnx2/README.TXT   ./README.bnx2.TXT
cp -f bnx2/RELEASE.TXT  ./RELEASE.bnx2.TXT
cp -f bnx2x/README.TXT  ./README.bnx2x.TXT
cp -f bnx2x/RELEASE.TXT ./RELEASE.bnx2x.TXT

%post
if [ -f /etc/modprobe.d/unsupported-modules ]; then
	sed -e 's/^allow_unsupported_modules.*/allow_unsupported_modules 1/' \
		/etc/modprobe.d/unsupported-modules > /tmp/unsupported-modules
	mv -f /tmp/unsupported-modules /etc/modprobe.d/
fi
depmod -a > /dev/null 2> /dev/null
exit 0

%postun
depmod -a > /dev/null 2> /dev/null
exit 0

%clean
rm -rf $RPM_BUILD_ROOT $RPM_BUILD_DIR/file.list.%{brcmname}

%files -f ../file.list.%{brcmname}
%doc LICENSE README.bnx2.TXT README.bnx2x.TXT RELEASE.bnx2.TXT RELEASE.bnx2x.TXT

%changelog
